// Buruiana Filip Cristian
// castori - 10 puncte

#include <stdio.h>

#define maxim(a, b) ((a > b) ? a : b)

int N, K, st[20005], sol[20005], Res = 2000000001;
int X[20005], Y[20005];

int modul(int x)
{ return (x < 0 ? -x : x); }

int dist(int i, int j)
{ return modul(X[i]-X[j]) + modul(Y[i]-Y[j]); }

int maxdist()
{
    int i, j, bst = 0;
    
    for (i = 1; i <= N; ++i)
        for (j = 1; j <= N; ++j)
            if (st[i] && st[j])
            {
                int d = dist(i, j);
                bst = maxim(bst, d);
            }
    return bst;
}

void back(int nivel, int sel)
{
    if (nivel == N+1)
    {
        if (sel == K)
        {
            int d = maxdist();
            if (d < Res)
            {
                Res = d;
                int i;
                for (i = 1; i <= N; ++i)
                    sol[i] = st[i];
            }
        }
        return ;
    }
    
    st[nivel] = 0; back(nivel+1, sel);
    if (sel < K)
    {
        st[nivel] = 1; back(nivel+1, sel+1);
    }
}

int main()
{
    int i;
    
    freopen("castori.in", "r", stdin);
    freopen("castori.out", "w", stdout);
    
    scanf("%d %d", &N, &K);
    for (i = 1; i <= N; ++i)
        scanf("%d %d", &X[i], &Y[i]); 
    
    back(1, 0);
    printf("%d\n", Res);
    
    return 0;
}
